﻿Imports System.Net
Imports System.Net.Sockets
Imports System.Text


Public Class Form1

    Dim peer As Socket
    Dim buffer(255) As Byte
    Public Delegate Sub DelegateSetText(ByVal text As String)
    Public Delegate Sub DelegateSetButtons(ByVal connectbt As Boolean, ByVal sendbt As Boolean, ByVal disconnectbt As Boolean)

    Private Sub bt_bind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_bind.Click

        Try
            If tb_ip.Text <> "" And tb_local.Text <> "" And tb_port.Text <> "" Then

                peer = New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
                Dim localEP As New IPEndPoint(IPAddress.Parse(tb_ip.Text), Integer.Parse(tb_local.Text))
                peer.Bind(localEP)
                peer.BeginReceive(buffer, 0, 255, SocketFlags.None, New AsyncCallback(AddressOf receiveCallback), peer)
                SetButtons(False, True, True)
                sb_status.Text = "Binded"
            Else
                sb_status.Text = "IP and Port needed"
            End If
        Catch ex As Exception
            sb_status.Text = "Binding not possible"
        End Try

    End Sub

    Private Sub bt_send_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_send.Click

        Dim sendtoEP As New IPEndPoint(IPAddress.Parse(tb_ip.Text), Integer.Parse(tb_port.Text))
        Dim SendData As Byte()

        If (cb_CRLF.Checked) Then
            SendData = Encoding.ASCII.GetBytes(tb_send.Text + Chr(13) + Chr(10))
        Else
            SendData = Encoding.ASCII.GetBytes(tb_send.Text)
        End If

        peer.SendTo(SendData, 0, SendData.Length, SocketFlags.None, sendtoEP)

    End Sub

    Private Sub bt_disconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_disconnect.Click

        disconnect()

    End Sub

    Private Sub setButtons(ByVal bindbt As Boolean, ByVal sendbt As Boolean, ByVal disconnectbt As Boolean)

        If Me.InvokeRequired Then
            Me.Invoke(New DelegateSetButtons(AddressOf setButtons), bindbt, sendbt, disconnectbt)
        Else
            bt_bind.Enabled = bindbt
            bt_send.Enabled = sendbt
            bt_disconnect.Enabled = disconnectbt
        End If

    End Sub

    Private Sub setText(ByVal receivetext As String)

        If (Me.InvokeRequired) Then
            Me.Invoke(New DelegateSetText(AddressOf setText), receivetext)
        Else
            tb_receive.Text += receivetext
        End If

    End Sub

    Private Sub receiveCallback(ByVal ar As IAsyncResult)

        Dim receivetext As String
        Dim bytesRead As Integer

        Try

            bytesRead = peer.EndReceive(ar)
            receivetext = String.Empty
            receivetext = Encoding.ASCII.GetString(buffer)
            setText(receivetext)
            Array.Clear(buffer, 0, buffer.Length)
            peer.BeginReceive(buffer, 0, 255, SocketFlags.None, New AsyncCallback(AddressOf receiveCallback), peer)

        Catch ex As Exception
            bytesRead = 0
        End Try

    End Sub

    Private Sub disconnect()

        Try
            peer.Shutdown(SocketShutdown.Both)
            peer.Close()
            sb_status.Text = "not bindeded"
            setButtons(True, False, False)
        Catch ex As Exception
            sb_status.Text = "Not able to stop binding"
        End Try

    End Sub
End Class
